Summary: GNU C Compiler
Name: gcc
Version: 2.7.2.1
Release: 2
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-2.7.2.1.tar.gz
Source1: gcc-c-skel 
Source2: gcc-c++-skel 
Source3: gcc-objc-skel
Patch0: sunsite.unc.edu:/pub/Linux/GCC/gcc-2.7.2-linux.diff.gz
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2.sparc.patch
Patch3: ftp://atheist.tamu.edu/pub/richard/linux/axp/rth-gcc-2.7.2-960814.diff.gz
Patch4: gcc-2.7.2-pg.patch
Patch5: gcc-2.7.2-flow.patch
Patch6: ftp://ftp.redhat.com/pub/alphabits/rth-gcc-2.7.2-961121.diff.gz
Requires: binutils

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: gcc = 2.7.2.1

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Requires: gcc = 2.7.2.1
Summary: Objective C support for gcc
Group: Development/Languages

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%prep
%setup
%patch0 -p2
%patch1 -p1 -b .rh
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p1
%patch6 -p1

for n in gcc-c-skel gcc-c++-skel gcc-objc-skel; do
    sed "s/ARCH/${RPM_ARCH}/g" < $RPM_SOURCE_DIR/$n | \
	sed "s/VERSION/${RPM_PACKAGE_VERSION}/g" > $n
done

%build

./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ ${RPM_ARCH}-linux

make LANGUAGES=c
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

%install
rm -f /lib/cpp
rm -f /usr/info/gcc.info* /usr/info/cpp.info*
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s" install

# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

gzip -n -9f /usr/info/gcc.info* /usr/info/cpp.info*

rm -f /usr/bin/cc
ln -sf gcc /usr/bin/cc
ln -sf cccp.1 /usr/man/man1/cpp.1

ln -sf ../usr/lib/gcc-lib/${RPM_ARCH}-linux/${RPM_PACKAGE_VERSION}/cpp /lib/cpp

%files -f gcc-c-skel
%doc NEWS PROBLEMS
%dir /usr/lib/gcc-lib
/usr/bin/gcc
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/man/man1/gcc.1

/usr/info/cpp.info*
/usr/info/gcc.info*

%files c++ -f gcc-c++-skel

%files objc -f gcc-objc-skel
